#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * SwItemViewIface:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SwItemViewIface SwItemViewIface;

/**
 * SwItemViewIfaceClass:
 *
 * The class of SwItemViewIface.
 */
typedef struct _SwItemViewIfaceClass SwItemViewIfaceClass;

GType sw_item_view_iface_get_type (void);
#define SW_TYPE_ITEM_VIEW_IFACE \
  (sw_item_view_iface_get_type ())
#define SW_ITEM_VIEW_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SW_TYPE_ITEM_VIEW_IFACE, SwItemViewIface))
#define SW_IS_ITEM_VIEW_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SW_TYPE_ITEM_VIEW_IFACE))
#define SW_ITEM_VIEW_IFACE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SW_TYPE_ITEM_VIEW_IFACE, SwItemViewIfaceClass))


typedef void (*sw_item_view_iface_start_impl) (SwItemViewIface *self,
    DBusGMethodInvocation *context);
void sw_item_view_iface_implement_start (SwItemViewIfaceClass *klass, sw_item_view_iface_start_impl impl);
/**
 * sw_item_view_iface_return_from_start:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_item_view_iface_return_from_start (DBusGMethodInvocation *context);
static inline void
sw_item_view_iface_return_from_start (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*sw_item_view_iface_refresh_impl) (SwItemViewIface *self,
    DBusGMethodInvocation *context);
void sw_item_view_iface_implement_refresh (SwItemViewIfaceClass *klass, sw_item_view_iface_refresh_impl impl);
/**
 * sw_item_view_iface_return_from_refresh:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_item_view_iface_return_from_refresh (DBusGMethodInvocation *context);
static inline void
sw_item_view_iface_return_from_refresh (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*sw_item_view_iface_stop_impl) (SwItemViewIface *self,
    DBusGMethodInvocation *context);
void sw_item_view_iface_implement_stop (SwItemViewIfaceClass *klass, sw_item_view_iface_stop_impl impl);
/**
 * sw_item_view_iface_return_from_stop:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_item_view_iface_return_from_stop (DBusGMethodInvocation *context);
static inline void
sw_item_view_iface_return_from_stop (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*sw_item_view_iface_close_impl) (SwItemViewIface *self,
    DBusGMethodInvocation *context);
void sw_item_view_iface_implement_close (SwItemViewIfaceClass *klass, sw_item_view_iface_close_impl impl);
/**
 * sw_item_view_iface_return_from_close:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_item_view_iface_return_from_close (DBusGMethodInvocation *context);
static inline void
sw_item_view_iface_return_from_close (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void sw_item_view_iface_emit_items_added (gpointer instance,
    const GPtrArray *arg_items);
void sw_item_view_iface_emit_items_removed (gpointer instance,
    const GPtrArray *arg_items);
void sw_item_view_iface_emit_items_changed (gpointer instance,
    const GPtrArray *arg_items);


G_END_DECLS
