#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * SwServiceIface:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SwServiceIface SwServiceIface;

/**
 * SwServiceIfaceClass:
 *
 * The class of SwServiceIface.
 */
typedef struct _SwServiceIfaceClass SwServiceIfaceClass;

GType sw_service_iface_get_type (void);
#define SW_TYPE_SERVICE_IFACE \
  (sw_service_iface_get_type ())
#define SW_SERVICE_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SW_TYPE_SERVICE_IFACE, SwServiceIface))
#define SW_IS_SERVICE_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SW_TYPE_SERVICE_IFACE))
#define SW_SERVICE_IFACE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SW_TYPE_SERVICE_IFACE, SwServiceIfaceClass))


typedef void (*sw_service_iface_get_static_capabilities_impl) (SwServiceIface *self,
    DBusGMethodInvocation *context);
void sw_service_iface_implement_get_static_capabilities (SwServiceIfaceClass *klass, sw_service_iface_get_static_capabilities_impl impl);
/**
 * sw_service_iface_return_from_get_static_capabilities:
 * @context: The D-Bus method invocation context
 * @out_caps: const gchar ** (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_service_iface_return_from_get_static_capabilities (DBusGMethodInvocation *context,
    const gchar **out_caps);
static inline void
sw_service_iface_return_from_get_static_capabilities (DBusGMethodInvocation *context,
    const gchar **out_caps)
{
  dbus_g_method_return (context,
      out_caps);
}

typedef void (*sw_service_iface_get_dynamic_capabilities_impl) (SwServiceIface *self,
    DBusGMethodInvocation *context);
void sw_service_iface_implement_get_dynamic_capabilities (SwServiceIfaceClass *klass, sw_service_iface_get_dynamic_capabilities_impl impl);
/**
 * sw_service_iface_return_from_get_dynamic_capabilities:
 * @context: The D-Bus method invocation context
 * @out_caps: const gchar ** (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_service_iface_return_from_get_dynamic_capabilities (DBusGMethodInvocation *context,
    const gchar **out_caps);
static inline void
sw_service_iface_return_from_get_dynamic_capabilities (DBusGMethodInvocation *context,
    const gchar **out_caps)
{
  dbus_g_method_return (context,
      out_caps);
}

typedef void (*sw_service_iface_request_avatar_impl) (SwServiceIface *self,
    DBusGMethodInvocation *context);
void sw_service_iface_implement_request_avatar (SwServiceIfaceClass *klass, sw_service_iface_request_avatar_impl impl);
/**
 * sw_service_iface_return_from_request_avatar:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_service_iface_return_from_request_avatar (DBusGMethodInvocation *context);
static inline void
sw_service_iface_return_from_request_avatar (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*sw_service_iface_credentials_updated_impl) (SwServiceIface *self,
    DBusGMethodInvocation *context);
void sw_service_iface_implement_credentials_updated (SwServiceIfaceClass *klass, sw_service_iface_credentials_updated_impl impl);
/**
 * sw_service_iface_return_from_credentials_updated:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_service_iface_return_from_credentials_updated (DBusGMethodInvocation *context);
static inline void
sw_service_iface_return_from_credentials_updated (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void sw_service_iface_emit_capabilities_changed (gpointer instance,
    const gchar **arg_caps);
void sw_service_iface_emit_avatar_retrieved (gpointer instance,
    const gchar *arg_path);
void sw_service_iface_emit_user_changed (gpointer instance);


G_END_DECLS
