#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * SwViewIface:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SwViewIface SwViewIface;

/**
 * SwViewIfaceClass:
 *
 * The class of SwViewIface.
 */
typedef struct _SwViewIfaceClass SwViewIfaceClass;

GType sw_view_iface_get_type (void);
#define SW_TYPE_VIEW_IFACE \
  (sw_view_iface_get_type ())
#define SW_VIEW_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SW_TYPE_VIEW_IFACE, SwViewIface))
#define SW_IS_VIEW_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SW_TYPE_VIEW_IFACE))
#define SW_VIEW_IFACE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SW_TYPE_VIEW_IFACE, SwViewIfaceClass))


typedef void (*sw_view_iface_start_impl) (SwViewIface *self,
    DBusGMethodInvocation *context);
void sw_view_iface_implement_start (SwViewIfaceClass *klass, sw_view_iface_start_impl impl);
/**
 * sw_view_iface_return_from_start:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_view_iface_return_from_start (DBusGMethodInvocation *context);
static inline void
sw_view_iface_return_from_start (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*sw_view_iface_refresh_impl) (SwViewIface *self,
    DBusGMethodInvocation *context);
void sw_view_iface_implement_refresh (SwViewIfaceClass *klass, sw_view_iface_refresh_impl impl);
/**
 * sw_view_iface_return_from_refresh:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_view_iface_return_from_refresh (DBusGMethodInvocation *context);
static inline void
sw_view_iface_return_from_refresh (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*sw_view_iface_stop_impl) (SwViewIface *self,
    DBusGMethodInvocation *context);
void sw_view_iface_implement_stop (SwViewIfaceClass *klass, sw_view_iface_stop_impl impl);
/**
 * sw_view_iface_return_from_stop:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_view_iface_return_from_stop (DBusGMethodInvocation *context);
static inline void
sw_view_iface_return_from_stop (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*sw_view_iface_close_impl) (SwViewIface *self,
    DBusGMethodInvocation *context);
void sw_view_iface_implement_close (SwViewIfaceClass *klass, sw_view_iface_close_impl impl);
/**
 * sw_view_iface_return_from_close:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_view_iface_return_from_close (DBusGMethodInvocation *context);
static inline void
sw_view_iface_return_from_close (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void sw_view_iface_emit_items_added (gpointer instance,
    const GPtrArray *arg_items);
void sw_view_iface_emit_items_removed (gpointer instance,
    const GPtrArray *arg_items);
void sw_view_iface_emit_items_changed (gpointer instance,
    const GPtrArray *arg_items);


G_END_DECLS
